// NOTE: it is recommended to use this even if you don't understand the following code.

using System;
using System.IO;
using System.Linq;
using System.Collections.Generic;

namespace andqueries {

    class Program {
        static void Main(String[] args) {
            StreamReader streamReader = new StreamReader(Console.OpenStandardInput());
            StreamWriter streamWriter = new StreamWriter(Console.OpenStandardOutput());
            // uncomment the two following lines if you want to read/write from files
            // streamReader = new StreamReader("input.txt");
            // streamWriter = new StreamWriter("output.txt");

            IEnumerator<String> it = GetEnumerator(streamReader);

            int N = Convert.ToInt32(Next(it));

            int[] A = new int[N - 1], B = new int[N - 1], W = new int[N - 1];
            for (int i = 0; i < N - 1; ++i) {
                A[i] = Convert.ToInt32(Next(it));
                B[i] = Convert.ToInt32(Next(it));
                W[i] = Convert.ToInt32(Next(it));
            }

            int Q = Convert.ToInt32(Next(it));

            int[] U = new int[Q], V = new int[Q], X = new int[Q];
            for (int i = 0; i < Q; ++i) {
                U[i] = Convert.ToInt32(Next(it));
                V[i] = Convert.ToInt32(Next(it));
                X[i] = Convert.ToInt32(Next(it));
            }

            long[] ans = new long[Q + 1];


            // INSERT YOUR CODE HERE


            for (int i = 0; i < Q + 1; ++i)
                streamWriter.Write($"{ans[i]} ");
            streamWriter.WriteLine($"");

            streamReader.Close();
            streamWriter.Close();
        }

        static IEnumerator<String> GetEnumerator(StreamReader sr) {
            String line;
            while ((line = sr.ReadLine()) != null) {
                String[] tokens = line.Split(' ').Where(t => t.Length > 0).ToArray();
                foreach (String t in tokens) {
                    yield return t;
                }
            }
        }

        static String Next(IEnumerator<String> iterator) {
            return iterator.MoveNext() ? iterator.Current : null;
        }
    }
}
